<?php

#
# APC UPS - Basic Status
#
# Author: Daniel Tarrero <daniel.tarrero@bluebrain.es>
#
# OID: .1.3.6.1.4.1.318.1.1.1.11.1.1.0
#

$no_http_headers = true;

error_reporting(E_ERROR);

include_once(dirname(__FILE__) . '/../include/global.php');
include_once(dirname(__FILE__) . '/../lib/snmp.php');

if (!isset($called_by_script_server)) {
	array_shift($_SERVER['argv']);
	print call_user_func_array('ss_upsBasicStatus', $_SERVER['argv']);
}

$result = array(
	"Abnormal Condition Present" => 0,
	"On Battery" => 0,
	"Low Battery" => 0,
	"On Line" => 0,

	"Replace Battery" => 0,
	"Serial Communication Established" => 0,
	"AVR Boost Active" => 0,
	"AVR Trim Active" => 0,

	"Overload" => 0,
	"Runtime Calibration" => 0,
	"Batteries Discharged" => 0,
	"Manual Bypass" => 0,

	"Software Bypass" => 0,
	"In Bypass due to Internal Fault" => 0,
	"In Bypass due to Supply Failure" => 0,
	"In Bypass due to Fan Failure" => 0,

	"Sleeping on a Timer" => 0,
	"Sleeping until Utility Power Returns" => 0,
	"On" => 0,
	"Rebooting" => 0,

	"Battery Communication Lost" => 0,
	"Graceful Shutdown Initiated" => 0,
	"Smart Boost or Smart Trim Fault" => 0,
	"Bad Output Voltage" => 0,

	"Battery Charger Failure" => 0,
	"High Battery Temperature" => 0,
	"Warning Battery Temperature" => 0,
	"Critical Battery Temperature" => 0,

	"Self Test In Progress" => 0,
	"Low Battery On Battery" => 0,
	"Graceful Shutdown Issued by Upstream Device" => 0,
	"Graceful Shutdown Issued by Downstream Device" => 0,

	"No Batteries Attached" => 0,
	"Synchronized Command is in Progress" => 0,
	"Synchronized Sleeping Command is in Progress" => 0,
	"Synchronized Rebooting Command is in Progress" => 0,

	"Inverter DC Imbalance" => 0,
	"Transfer Relay Failure" => 0,
	"Shutdown or Unable to Transfer" => 0,
	"Low Battery Shutdown" => 0,

	"Electronic Unit Fan Failure" => 0,
	"Main Relay Failure" => 0,
	"Bypass Relay Failure" => 0,
	"Temporary Bypass" => 0,

	"High Internal Temperature" => 0,
	"Battery Temperature Sensor Fault" => 0,
	"Input Out of Range for Bypass" => 0,
	"DC Bus Overvoltage" => 0,

	"PFC Failure" => 0,
	"Critical Hardware Fault" => 0,
	"Green Mode ECO Mode" => 0,
	"Hot Standby" => 0,

	"Emergency Power Off Activated" => 0,
	"Load Alarm Violation" => 0,
	"Bypass Phase Fault" => 0,
	"UPS Internal Communication Failure" => 0,

	"UnKnown Data 57" => 0,
	"UnKnown Data 58" => 0,
	"UnKnown Data 59" => 0,
	"UnKnown Data 60" => 0,
	"UnKnown Data 61" => 0,
	"UnKnown Data 62" => 0,
	"UnKnown Data 63" => 0,
	"UnKnown Data 64" => 0
);

function ss_upsBasicStatus($host_id_or_hostname) {
	global $config;
	global $result;
	$resultstr = "";
	$oid = ".1.3.6.1.4.1.318.1.1.1.11.1.1.0";

        if (!is_numeric($host_id_or_hostname)) {
                $hostid = db_fetch_cell_prepared('SELECT id FROM host WHERE hostname = ?', array($host_id_or_hostname));
        } else {
                $hostid = $host_id_or_hostname;
        }

	if ($hostid > 0) {
                $host = db_fetch_row("SELECT hostname, snmp_community, snmp_version, snmp_username, snmp_password, 
                        snmp_auth_protocol, snmp_priv_passphrase, snmp_priv_protocol, snmp_context, 
                        snmp_port, snmp_timeout, max_oids 
                        FROM host 
                        WHERE id=$hostid");
                if (sizeof($host)) {
                        $walk = cacti_snmp_walk($host['hostname'], $host['snmp_community'], $oid, $host['snmp_version'],
                                $host['snmp_username'], $host['snmp_password'],
                                $host['snmp_auth_protocol'], $host['snmp_priv_passphrase'], $host['snmp_priv_protocol'],
                                $host['snmp_context'], $host['snmp_port'], $host['snmp_timeout'],
                                read_config_option('snmp_retries'), $host['max_oids'], SNMP_WEBUI);
			if (!empty($walk)) {
				$i = 0;
				$values_array = str_split($walk[0]['value']);
				$max = count($values_array);
				foreach ($result as $key => $value) {
					$result[$key] = $values_array[$i];
					#$resultstr .= str_replace(" ", "_", strtolower($key)).":".$values_array[$i];
					$resultstr .= "d_".sprintf("%02d", $i + 1).":".$values_array[$i];
					$i++;
					if ($i !== $max) {
						$resultstr .= " ";
					}
				}
				return $resultstr;
			}
                }
	}

}

?>
